(function () {

/* Imports */
var Meteor = Package.meteor.Meteor;
var global = Package.meteor.global;
var meteorEnv = Package.meteor.meteorEnv;
var ECMAScript = Package.ecmascript.ECMAScript;
var HTTP = Package.http.HTTP;
var HTTPInternals = Package.http.HTTPInternals;
var meteorInstall = Package.modules.meteorInstall;
var meteorBabelHelpers = Package['babel-runtime'].meteorBabelHelpers;
var Promise = Package.promise.Promise;
var Symbol = Package['ecmascript-runtime-server'].Symbol;
var Map = Package['ecmascript-runtime-server'].Map;
var Set = Package['ecmascript-runtime-server'].Set;

/* Package-scope variables */
var SandstormAutoupdateApps;

var require = meteorInstall({"node_modules":{"meteor":{"sandstorm-autoupdate-apps":{"autoupdate-apps.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                             //
// packages/sandstorm-autoupdate-apps/autoupdate-apps.js                                       //
//                                                                                             //
/////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                               //
// Sandstorm - Personal Cloud Sandbox                                                          // 1
// Copyright (c) 2015 Sandstorm Development Group, Inc. and contributors                       // 2
// All rights reserved.                                                                        // 3
//                                                                                             // 4
// Licensed under the Apache License, Version 2.0 (the "License");                             // 5
// you may not use this file except in compliance with the License.                            // 6
// You may obtain a copy of the License at                                                     // 7
//                                                                                             // 8
//   http://www.apache.org/licenses/LICENSE-2.0                                                // 9
//                                                                                             // 10
// Unless required by applicable law or agreed to in writing, software                         // 11
// distributed under the License is distributed on an "AS IS" BASIS,                           // 12
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                    // 13
// See the License for the specific language governing permissions and                         // 14
// limitations under the License.                                                              // 15
SandstormAutoupdateApps = {};                                                                  // 17
                                                                                               //
SandstormAutoupdateApps.updateAppIndex = function (db) {                                       // 19
  db.updateAppIndex();                                                                         // 20
};                                                                                             // 21
                                                                                               //
Meteor.methods({                                                                               // 23
  updateAppIndex: function () {                                                                // 24
    // An undocumented method that the admin can use to force an app index update immediately.
    // Probably not useful except for debugging.                                               // 26
    if (!Meteor.user().isAdmin) {                                                              // 28
      throw new Meteor.Error(403, "Must be admin.");                                           // 29
    }                                                                                          // 30
                                                                                               //
    SandstormAutoupdateApps.updateAppIndex(this.connection.sandstormDb);                       // 32
  },                                                                                           // 33
  updateApps: function (packages) {                                                            // 35
    var _this = this;                                                                          // 35
                                                                                               //
    check(packages, [String]);                                                                 // 36
                                                                                               //
    if (!this.userId) {                                                                        // 37
      throw new Meteor.Error(403, "Must be logged in to update apps.");                        // 38
    }                                                                                          // 39
                                                                                               //
    var db = this.connection.sandstormDb;                                                      // 41
    var backend = this.connection.sandstormBackend;                                            // 42
    packages.forEach(function (packageId) {                                                    // 44
      var pack = db.collections.packages.findOne({                                             // 45
        _id: packageId                                                                         // 45
      });                                                                                      // 45
                                                                                               //
      if (!pack || !pack.manifest) {                                                           // 46
        throw new Error("No such package on server: " + packageId);                            // 47
      } else {                                                                                 // 48
        db.addUserActions(_this.userId, packageId);                                            // 49
        db.upgradeGrains(pack.appId, pack.manifest.appVersion, packageId, backend);            // 50
        db.deleteUnusedPackages(pack.appId);                                                   // 51
      }                                                                                        // 52
    });                                                                                        // 53
  }                                                                                            // 54
});                                                                                            // 23
/////////////////////////////////////////////////////////////////////////////////////////////////

}}}}},{
  "extensions": [
    ".js",
    ".json"
  ]
});
require("./node_modules/meteor/sandstorm-autoupdate-apps/autoupdate-apps.js");

/* Exports */
if (typeof Package === 'undefined') Package = {};
(function (pkg, symbols) {
  for (var s in symbols)
    (s in pkg) || (pkg[s] = symbols[s]);
})(Package['sandstorm-autoupdate-apps'] = {}, {
  SandstormAutoupdateApps: SandstormAutoupdateApps
});

})();

//# sourceMappingURL=sandstorm-autoupdate-apps.js.map
